static char rcsid[] = "$Id: filemenu.c,v 1.4 1991/07/16 14:51:56 jtsillas Exp $";

/* filemenu.c
 *
 *  Construct a file menu (directory browser) which allows a user to go
 *  up and down the directory tree, to select text files to display, and
 *  to select executable files to debug.  The file menu is popped up by
 *  the 'file' command button.
 *  Duane Voth (duanev@mcc.com) contributed to the layout of the file menu, 
 *  plus some code and ideas.
 *
 *  File():		Command callback for the 'file' command button.
 */

#include <ctype.h>
#include <X11/Xos.h>
#include <sys/stat.h>

#   include <stdio.h>
#   include <sys/param.h>
#   include <sys/types.h>
#   include <dirent.h>

#include "global.h"
#include <Xm/Xm.h>
#include <Xm/FileSB.h>

void CancelCallBack()
{
  XtUnmanageChild(fileSel);
}

void OKCallBack(w, client_data, call_data)
Widget w;
caddr_t client_data;
XmFileSelectionBoxCallbackStruct *call_data;
{
  Widget TextW;

  char *string;
  char command[256];
  Arg args[5];
  struct stat statbuf;

  TextW = XmFileSelectionBoxGetChild(w, XmDIALOG_TEXT);
  string = (char *)XmTextGetString(TextW);

  XtUnmanageChild(fileSel);
#ifdef NCLX
  if(lstat(string, &statbuf) == -1)
#endif
#if SCO
  if(stat(string, &statbuf) == -1)
#endif
    {
      UpdateMessageWindow("Could not stat file or directory", NULL);
      if(string) XtFree(string);
      return;
    }
  if (statbuf.st_mode & S_IFDIR)
    sprintf(command, "cd %s\n", string);
  else
    if (statbuf.st_mode & S_IEXEC)             /* is executable */
      {
	sprintf(command, "exec-file %s\n", string);
	send_command(command);
	AppendDialogText(command);
	
	Echo = True;
	Parse = True;
	Prompt = False;
	while (!Prompt)
	  read_dbx();
	
	sprintf(command, "symbol-file %s\n", string);
      }
    else
      sprintf(command, "list %s:1\n", string);
  
  send_command(command);
  AppendDialogText(command);
  XtFree(string);
}


/*  File command button callback.
 */
/* ARGSUSED */
void File(w, client_data, call_data)
    Widget w;
    caddr_t client_data;
    caddr_t call_data;
{
    Arg 	args[MAXARGS];
    Cardinal	n;
    Position	x, y, x_offset;
    Dimension	fileMenu_width, fileMenuLabel_width, border_width,
		width, dialog_width;

    XtManageChild(fileSel);

    UpdateMessageWindow("Select a file or directory", NULL);
}




